%define major	6
%define lib_name_orig lib%{name}
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d

Summary:	Library for reading lines from a terminal
Name:		readline
Version:	6.2
%define subrel	1
Release:	%mkrel 9
License:	GPLv3
Group:		System/Libraries
Url:		http://tiswww.case.edu/php/chet/readline/rltop.html
Source0:	ftp://ftp.gnu.org/gnu/readline/%{name}-%{version}.tar.gz
Source1:	ftp://ftp.gnu.org/gnu/readline/%{name}-%{version}.tar.gz.sig
Patch0:		readline-4.3-no_rpath.patch
Patch1:		readline-4.1-outdated.patch
Patch2:		rl-header.patch
Patch3:		rl-attribute.patch
Patch4:		readline-6.0-fix-shared-libs-perms.patch
Patch5:		readline-6.2-CVE-2014-2524.patch
# add workaround for problem in gdb
# in new version of readline needs to be deleted
Patch23:	readline-6.2-gdb.patch
# upstream patches:
Patch101:	ftp://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-001
Patch103:	ftp://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-003
Patch104:	ftp://ftp.gnu.org/gnu/readline/readline-6.2-patches/readline62-004
BuildRequires:	ncursesw-devel

%description
The "readline" library will read a line from the terminal and return it,
allowing the user to edit the line with the standard emacs editing keys.
It allows the programmer to give the user an easier-to-use and more
intuitive interface.

%package -n %{libname}
Summary:	Shared libraries for readline
Group:		System/Libraries
Requires(pre):	filesystem >= 2.1.9-18
Provides:	%{name} = %{version}-%{release}
Obsoletes:	%{name}

%description -n	%{libname}
This package contains the library needed to run programs dynamically
linked to readline.

%package doc
Summary:	Readline documentation in GNU info format
Group:		Documentation
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-doc = %{version}-%{release}
Obsoletes:	%{libname}-doc

%description doc
This package contains readline documentation in the GNU info format.

%package -n %{develname}
Summary:	Files for developing programs that use the readline library
Group:		Development/C
Requires(pre):	filesystem >= 2.1.9-18
Requires:	ncursesw-devel
Requires:	%{libname} = %{version}-%{release}
Provides:	%{lib_name_orig}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname readline 5 -d}
Obsoletes:	%{name}-devel < 6.0-2

%description -n	%{develname}
The "readline" library will read a line from the terminal and return it,
using prompt as a prompt.  If prompt is null, no prompt is issued.  The
line returned is allocated with malloc(3), so the caller must free it when
finished.  The line returned has the final newline removed, so only the
text of the line remains.

%prep
%setup -q
%patch0 -p1 -b .no_rpath
%patch1 -p1 -b .outdated
%patch2 -p1 -b .header
%patch3 -p1 -b .attribute
%patch4 -p1 -b .fix-perms
%patch5 -p0 -b .CVE-2014-2524
%patch23 -p1 -b .gdb
%patch101 -p0 -b .001
%patch103 -p0 -b .003
%patch104 -p0 -b .004
# Fix upstream perm Bug #3053
chmod 644 examples/rlfe/ChangeLog

libtoolize --copy --force

%build

export LDFLAGS="-I%{_includedir}/ncursesw -lncursesw"

%configure2_5x \
	 --with-curses \
	 --enable-multibyte

perl -p -i -e 's|-Wl,-rpath.*||' shlib/Makefile

%make

%install
%makeinstall_std

perl -p -i -e 's|/usr/local/bin/perl|/usr/bin/perl|' doc/texi2html

%post doc
%{_install_info history.info}
%{_install_info readline.info}

%preun doc
%{_remove_install_info history.info}
%{_remove_install_info readline.info}

%files -n %{libname}
%{_libdir}/lib*.so.%{major}*

%files doc
%{_infodir}/*info*

%files -n %{develname}
%doc CHANGELOG CHANGES MANIFEST README USAGE
%doc doc examples support
%{_mandir}/man3/*
%{_datadir}/readline
%{_includedir}/readline
%{_libdir}/lib*.a
%{_libdir}/lib*.so


%changelog
* Wed Jul 23 2014 luigiwalser <luigiwalser> 6.2-9.1.mga4
+ Revision: 656026
- add upstream patches to fix infinite loop in vi mode and slowness pasting text
- rediff upstream patch to fix CVE-2014-2524

* Sat Oct 19 2013 umeabot <umeabot> 6.2-9.mga4
+ Revision: 527736
- Mageia 4 Mass Rebuild

* Wed Jun 12 2013 tv <tv> 6.2-8.mga4
+ Revision: 442014
- add FC patch for GDB

* Mon Jan 14 2013 umeabot <umeabot> 6.2-7.mga3
+ Revision: 380254
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Oct 14 2012 ennael <ennael> 6.2-6.mga3
+ Revision: 305465
- Documentation group

* Sat Jul 21 2012 colin <colin> 6.2-5.mga3
+ Revision: 273158
- Update for usrmove

* Thu Dec 29 2011 fwang <fwang> 6.2-4.mga2
+ Revision: 188691
- update license

* Thu Dec 15 2011 barjac <barjac> 6.2-3.mga2
+ Revision: 182275
- Changed Requires, Removed CFLAGS/CXXFLAGS mod, cleaned
- Change args to *FLAGS from ncurses to ncursesw
- Fix perm - bug #3053 and some cleaning

  + misc <misc>
    - link with ncursesw, fix #2156

* Fri Apr 15 2011 ahmad <ahmad> 6.2-1.mga1
+ Revision: 85627
- update to 6.2
- add upstream patch 001

* Sat Jan 08 2011 blino <blino> 6.1-4.mga1
+ Revision: 655
- remove old ldconfig calls
- imported package readline

